/*
 File: rule_def_phrasesym.cpp
 Date and Time: Fri Jan 30 18:55:22 2015 
*/
#include "rule_def_phrase.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_rule_def_phrase;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_rule_def_phrase::TH_rule_def_phrase(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_rule_def_phrase;
  NS_rule_def_phrase::Crule_def_phrase Crule_def_phrase_;// parallel-parser's parse table
#define ssPARSE_TABLE Crule_def_phrase_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_rule_def_phrase::PROC_TH_rule_def_phrase(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_rule_def_phrase";
  static bool one_time(false);
  static NS_rule_def_phrase::Crule_def_phrase* NS_rule_def_phrase_Crule_def_phrase_(0);// parallel-parser's fsm table
  static Parser* NS_rule_def_phrase_Crule_def_phrase_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_rule_def_phrase_Crule_def_phrase_ = new NS_rule_def_phrase::Crule_def_phrase();// parallel-parser's fsm table
    NS_rule_def_phrase_Crule_def_phrase_parser = new Parser(*NS_rule_def_phrase_Crule_def_phrase_,Caller_pp);
  }
 proc_parser = NS_rule_def_phrase_Crule_def_phrase_parser;
#include "wproc_pp_core.h"
}
void 
Crule_def_phrase::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rrule_def_phrase_:{
       Rrule_def_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 12;
    

     sym->sr1();
     return;}
    case rhs1_Rrule_cweb_k_:{
       Rrule_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rrule_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_cweb_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rrule_cweb_k_:{
       Rrule_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rrule_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_cweb_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rrule_cweb_k_:{
       Rrule_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rrule_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_cweb_k*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs1_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr4();
     return;}
    case rhs1_Rad_ab_tags_:{
       Rad_ab_tags* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tags(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tags*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rad_ab_tags_:{
       Rad_ab_tags* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tags(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tags*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs3_Rad_ab_tags_:{
       Rad_ab_tags* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tags(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tags*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs1_Rad_ab_tag_:{
       Rad_ab_tag* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tag(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tag*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rad_ab_tag_:{
       Rad_ab_tag* sym;
     if(re->rule_ == 0){
       sym = new Rad_ab_tag(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rad_ab_tag*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rrule_parameters_:{
       Rrule_parameters* sym;
     if(re->rule_ == 0){
       sym = new Rrule_parameters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_parameters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rrule_parameters_:{
       Rrule_parameters* sym;
     if(re->rule_ == 0){
       sym = new Rrule_parameters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_parameters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs3_Rrule_parameters_:{
       Rrule_parameters* sym;
     if(re->rule_ == 0){
       sym = new Rrule_parameters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_parameters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rrule_parameter_:{
       Rrule_parameter* sym;
     if(re->rule_ == 0){
       sym = new Rrule_parameter(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_parameter*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rrule_parameter_:{
       Rrule_parameter* sym;
     if(re->rule_ == 0){
       sym = new Rrule_parameter(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_parameter*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs3_Rrule_parameter_:{
       Rrule_parameter* sym;
     if(re->rule_ == 0){
       sym = new Rrule_parameter(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_parameter*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rlhs_phrase_:{
       Rlhs_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rlhs_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlhs_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rlhs_phrase_:{
       Rlhs_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rlhs_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlhs_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rparallel_monitor_phrase_:{
       Rparallel_monitor_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_monitor_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_monitor_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rparallel_monitor_phrase_:{
       Rparallel_monitor_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_monitor_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_monitor_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rrule_body_:{
       Rrule_body* sym;
     if(re->rule_ == 0){
       sym = new Rrule_body(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_body*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     return;}
    case rhs1_Rsubrules_:{
       Rsubrules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rsubrules_:{
       Rsubrules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rsubrules_:{
       Rsubrules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Ropen_par_:{
       Ropen_par* sym;
     if(re->rule_ == 0){
       sym = new Ropen_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Ropen_par_:{
       Ropen_par* sym;
     if(re->rule_ == 0){
       sym = new Ropen_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rclose_par_:{
       Rclose_par* sym;
     if(re->rule_ == 0){
       sym = new Rclose_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclose_par_:{
       Rclose_par* sym;
     if(re->rule_ == 0){
       sym = new Rclose_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Ropen_brace_:{
       Ropen_brace* sym;
     if(re->rule_ == 0){
       sym = new Ropen_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Ropen_brace_:{
       Ropen_brace* sym;
     if(re->rule_ == 0){
       sym = new Ropen_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    default: return;
   }
}
